/*******************************************************************************
 * Copyright (c) 2015-2016 ONERA.
 * Ce logiciel est la propriété de l’ONERA (the French Aerospace Lab).
 * Tous droits réservés.
 *
 * Ce programme et les éléments qui l'accompagnent sont mis à disposition
 * aux conditions définies par le contrat de licence logiciel CeCILL-C soumise
 * au droit français et respectant les principes de diffusion des logiciels libres.
 * Vous pouvez utiliser, modifier et/ou redistribuer ce programme
 * sous les conditions de la licence CeCILL-C (http://www.cecill.info).

 * This software is property of ONERA (the French Aerospace Lab).
 * All rights reserved.
 *
 * This program and the accompanying materials are made available under
 * the terms of the CeCILL-C license under French law and
 * abiding by the rules of distribution of free software.
 * You can  use, modify and/ or redistribute the software under the terms of
 * the CeCILL-C license (http://www.cecill.info).
 *
 * Contributeurs/contributors:
 *     Guillaume Infantes (ONERA - Centre de Toulouse) - initial API and implementation
 *
 *******************************************************************************/

#ifndef ALTA_PREDEFINED_DOMAIN_H_
#define ALTA_PREDEFINED_DOMAIN_H_

#include "DiscreteDomain.hh"
#include <vector>
#include <stdint.h>

namespace epoch {
  namespace altarica {


    class PredefinedDomain : public DiscreteDomain {

    protected:
      bool bool_; //or int
    public:
      PredefinedDomain(bool type);
      virtual unsigned int index(std::string arg) const;
      virtual std::string  text(unsigned int index) const;
      //      virtual std::vector<Variable*> * flatten(Variable* v) const;
      virtual Value * toValue() const;
      virtual int getMin() const;
      virtual int getMax() const;
      virtual Value * getValue(int i);
      virtual std::string toString() const ;
      static int min(bool);
      static int max(bool);
      bool isBooleanDomain() const {return bool_;}
      virtual ~PredefinedDomain();
    };
  }
}

#endif
